pcl::ESFEstimation< PointInT, PointOutT > Class Template Reference
Module features

ESFEstimation estimates the ensemble of shape functions descriptors for a given point cloud dataset containing points. More...

`#include <pcl/features/esf.h>`

Inheritance diagram for pcl::ESFEstimation< PointInT, PointOutT >:

## Public Types

typedef boost::shared_ptr< ESFEstimation< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const ESFEstimation< PointInT, PointOutT > > | ConstPtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ESFEstimation ()
| Empty constructor. More...
void | compute (PointCloudOut &output)
| Overloaded computed method from pcl::Feature. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | computeFeature (PointCloudOut &output)
| Estimate the Ensebmel of Shape Function (ESF) descriptors at a set of points given by <setInputCloud (),. More...
int | lci (const int x1, const int y1, const int z1, const int x2, const int y2, const int z2, float &ratio, int &incnt, int &pointcount)
| ... More...
void | computeESF (PointCloudIn &pc, std::vector< float > &hist)
| ... More...
void | voxelize9 (PointCloudIn &cluster)
| ... More...
void | cleanup9 (PointCloudIn &cluster)
| ... More...
void | scale_points_unit_sphere (const pcl::PointCloud< PointInT > &pc, float scalefactor, Eigen::Vector4f &centroid)
| ... More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Additional Inherited Members

Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT = pcl::ESFSignature640>
class pcl::ESFEstimation< PointInT, PointOutT >

ESFEstimation estimates the ensemble of shape functions descriptors for a given point cloud dataset containing points.

Shape functions are D2, D3, A3. For more information about the ESF descriptor, see: Walter Wohlkinger and Markus Vincze, "Ensemble of Shape Functions for 3D Object Classification", IEEE International Conference on Robotics and Biomimetics (IEEE-ROBIO), 2011

Author
  Walter Wohlkinger

Definition at line 59 of file esf.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointOutT = pcl::ESFSignature640>

typedef boost::shared_ptr<const ESFEstimation<PointInT, PointOutT> > pcl::ESFEstimation< PointInT, PointOutT >::ConstPtr

Definition at line 63 of file esf.h.

## PointCloudIn

template<typename PointInT , typename PointOutT = pcl::ESFSignature640>

typedef pcl::PointCloud<PointInT> pcl::ESFEstimation< PointInT, PointOutT >::PointCloudIn

Definition at line 73 of file esf.h.

## PointCloudOut

template<typename PointInT , typename PointOutT = pcl::ESFSignature640>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::ESFEstimation< PointInT, PointOutT >::PointCloudOut

Definition at line 74 of file esf.h.

## Ptr

template<typename PointInT , typename PointOutT = pcl::ESFSignature640>

typedef boost::shared_ptr<ESFEstimation<PointInT, PointOutT> > pcl::ESFEstimation< PointInT, PointOutT >::Ptr

Definition at line 62 of file esf.h.

## Constructor & Destructor Documentation

## ESFEstimation()

template<typename PointInT , typename PointOutT = pcl::ESFSignature640>

pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 77 of file esf.h.

References pcl::ESFEstimation< PointInT, PointOutT >::cleanup9(), pcl::ESFEstimation< PointInT, PointOutT >::compute(), pcl::ESFEstimation< PointInT, PointOutT >::computeESF(), pcl::ESFEstimation< PointInT, PointOutT >::computeFeature(), pcl::Feature< PointInT, PointOutT >::feature_name_, pcl::Feature< PointInT, PointOutT >::k_, pcl::ESFEstimation< PointInT, PointOutT >::lci(), pcl::ESFEstimation< PointInT, PointOutT >::scale_points_unit_sphere(), pcl::Feature< PointInT, PointOutT >::search_radius_, and pcl::ESFEstimation< PointInT, PointOutT >::voxelize9().

## Member Function Documentation

## cleanup9()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::cleanup9 | ( | PointCloudIn & | cluster | ) |

protected

...

Definition at line 454 of file esf.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## compute()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

Overloaded computed method from pcl::Feature.

Parameters

  [out] | output | the resultant point cloud model dataset containing the estimated features

Definition at line 508 of file esf.hpp.

References pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## computeESF()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::computeESF | ( | PointCloudIn & | pc,
|  | std::vector< float > & | hist
| ) |  |

protected

...

Definition at line 52 of file esf.hpp.

References pcl::euclideanDistance(), and pcl::PointCloud< PointT >::points.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## computeFeature()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

protected virtual

Estimate the Ensebmel of Shape Function (ESF) descriptors at a set of points given by <setInputCloud (),.

Parameters

  output | the resultant point cloud model histogram that contains the ESF feature estimates

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 536 of file esf.hpp.

References pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, and pcl::PointCloud< PointT >::width.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## lci()

template<typename PointInT , typename PointOutT >

int pcl::ESFEstimation< PointInT, PointOutT >::lci | ( | const int | x1,
|  | const int | y1,
|  | const int | z1,
|  | const int | x2,
|  | const int | y2,
|  | const int | z2,
|  | float & | ratio,
|  | int & | incnt,
|  | int & | pointcount
| ) |  |

protected

...

Definition at line 306 of file esf.hpp.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## scale_points_unit_sphere()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::scale_points_unit_sphere | ( | const pcl::PointCloud< PointInT > & | pc,
|  | float | scalefactor,
|  | Eigen::Vector4f & | centroid
| ) |  |

protected

...

Definition at line 483 of file esf.hpp.

References pcl::compute3DCentroid(), pcl::demeanPointCloud(), pcl::euclideanDistance(), and pcl::transformPointCloud().

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

## voxelize9()

template<typename PointInT , typename PointOutT >

void pcl::ESFEstimation< PointInT, PointOutT >::voxelize9 | ( | PointCloudIn & | cluster | ) |

protected

...

Definition at line 425 of file esf.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::ESFEstimation< PointInT, PointOutT >::ESFEstimation().

The documentation for this class was generated from the following files:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/esf.h
- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/features/include/pcl/features/impl/esf.hpp